import { Component, ChangeDetectorRef } from '@angular/core';
import { ReviewPage } from '../review/review.page';
import { ModalController, MenuController, NavController } from '@ionic/angular';
import { EventService } from '../../../services/event.service';
import { ActivatedRoute, Router } from '@angular/router';
import { EnvService } from 'src/app/services/env.service';
import { AuthService } from 'src/app/services/auth.service';
import { IchambaService } from 'src/app/services/ichamba.service';
import { TranslateService } from '@ngx-translate/core';
import { LanguageService } from 'src/app/services/language.service';
import { AlertService } from 'src/app/services/alert.service';
import { AlertController } from '@ionic/angular';

@Component({
  selector: 'app-finished',
  templateUrl: './finished.page.html',
  styleUrls: ['./finished.page.scss'],
  standalone: false
})
export class FinishedPage {

  fcontracts: any[] = [];
  fcontracts_dates: any[] = [];
  lang: boolean = false;
  loading = true;

  constructor(
    private modalController: ModalController,
    private menu: MenuController,
    private navCtrl: NavController,
    private events: EventService,
    private activatedRoute: ActivatedRoute,
    private router: Router,
    private alertController: AlertController,
    private authService: AuthService,
    private alertService: AlertService,
    private ichambaService: IchambaService,
    private translateService: TranslateService,
    private languageService: LanguageService,
    private env: EnvService,
    private cdr: ChangeDetectorRef,
  ) {
    this.events.subscribe('refreshccontracts', (data) => {
      this.getfcontracts();
    });
  }

  ionViewWillEnter() {
    this.lang = this.languageService.getDefaultLanguage() === 'es';
    this.loading = true;
    this.getfcontracts();
  }

  refresh(event: any) {
    this.ichambaService.getFinishedcontracts().subscribe(
      data => {
        this.fcontracts = data;
        this.fcontracts_dates = [];
        for (var i of this.fcontracts) {
          const locale = this.lang ? 'es-US' : 'en-US';
          this.fcontracts_dates.push(new Date((new Date(i.date).toLocaleString('en-US') + ' UTC').replace(',', '')).toLocaleDateString(locale, { weekday: 'long', year: 'numeric', month: 'short', day: 'numeric', hour: 'numeric', minute: 'numeric', timeZoneName: 'long' }));
        }
        this.cdr.detectChanges();
        event.target.complete();
      }, error => {
        this.alertService.presentToast(this.translateService.instant('alerts.error') + error['status']);
        event.target.complete();
      });
  }

  getfcontracts() {
    this.ichambaService.getFinishedcontracts().subscribe(
      data => {
        this.fcontracts = data;
        this.fcontracts_dates = [];
        for (var i of this.fcontracts) {
          const locale = this.lang ? 'es-US' : 'en-US';
          this.fcontracts_dates.push(new Date((new Date(i.date).toLocaleString('en-US') + ' UTC').replace(',', '')).toLocaleDateString(locale, { weekday: 'long', year: 'numeric', month: 'short', day: 'numeric', hour: 'numeric', minute: 'numeric', timeZoneName: 'long' }));
        }
        this.loading = false;
        this.cdr.detectChanges();
      }, error => {
        this.loading = false;
        this.alertService.presentToast(this.translateService.instant('alerts.error') + error['status']);
      });
  }

  reviewContract(contract_id: String) {
    this.navCtrl.navigateForward(['/review/', contract_id]);
  }

  addExtra(contract_id: String, supplier: String) {
    this.navCtrl.navigateForward(['/extra/', { contract_id: contract_id, supplier: supplier }]);
  }

  reportContract(contract_id: String) {
    this.router.navigate(['/report/', contract_id]);
  }

}
